#!/usr/bin/env node



/*
 * BOOTSTRAP
 */

const _fs      = require('fs');
const _path    = require('path');
const _PROJECT = _path.resolve(__dirname, '../');



/*
 * IMPLEMENTATION
 */

let files_html = [];
let files_node = [];

_fs.readdirSync(_PROJECT + '/source/platform/html').forEach(function(file) {
	files_html.push(_fs.readFileSync(_PROJECT + '/source/platform/html/' + file).toString('utf8'));
});

_fs.readdirSync(_PROJECT + '/source/platform/node').forEach(function(file) {
	files_html.push(_fs.readFileSync(_PROJECT + '/source/platform/node/' + file).toString('utf8'));
});


let main_html = files_html.map(function(file) {
	return file.trim();
}).join('\n');

let main_node = files_node.map(function(file) {
	return file.trim();
}).join('\n');



main_html_es6 = main_html;
main_node_es6 = main_node;

main_html_es5 = main_html_es6;
main_html_es5 = main_html_es5.split('const ').join('var ');
main_html_es5 = main_html_es5.split('let ').join('var ');

main_node_es5 = main_node_es6;
main_node_es5 = main_node_es5.split('const ').join('var ');
main_node_es5 = main_node_es5.split('let ').join('var ');


_fs.writeFileSync(_PROJECT + '/build/html/components.es5.js', main_html_es5);
_fs.writeFileSync(_PROJECT + '/build/html/components.es6.js', main_html_es6);
_fs.writeFileSync(_PROJECT + '/build/node/components.es5.js', main_node_es5);
_fs.writeFileSync(_PROJECT + '/build/node/components.es6.js', main_node_es6);

