#!/usr/bin/env node



/*
 * BOOTSTRAP
 */

const _fs      = require('fs');
const _path    = require('path');
const _PROJECT = _path.resolve(__dirname, '../');



/*
 * IMPLEMENTATION
 */

let main_html  = _fs.readFileSync(_PROJECT + '/source/platform/html/console.js').toString('utf8');
let main_node  = _fs.readFileSync(_PROJECT + '/source/platform/node/console.js').toString('utf8');
let style_html = _fs.readFileSync(_PROJECT + '/source/platform/html/console.css').toString('utf8').split('\n').map(function(line) {

	let tmp = line.trim();
	if (line === '}') {

		return line + '\n';

	} else {

		if (tmp.indexOf(': ') !== -1) {
			tmp = tmp.split(': ').join(':');
		}

		return tmp;

	}

}).join('').trim();


main_html_es6 = main_html.replace('"__CSS__"', JSON.stringify(style_html.split('\n'), null, '\t') + '.join(\'\\n\')');

main_html_es5 = main_html_es6;
main_html_es5 = main_html_es5.split('const ').join('var ');
main_html_es5 = main_html_es5.split('let ').join('var ');


main_node_es6 = main_node;

main_node_es5 = main_node_es6;
main_node_es5 = main_node_es5.split('const ').join('var ');
main_node_es5 = main_node_es5.split('let ').join('var ');


_fs.writeFileSync(_PROJECT + '/build/html/console.es5.js', main_html_es5);
_fs.writeFileSync(_PROJECT + '/build/html/console.es6.js', main_html_es6);
_fs.writeFileSync(_PROJECT + '/build/node/console.es5.js', main_node_es5);
_fs.writeFileSync(_PROJECT + '/build/node/console.es6.js', main_node_es6);

